;==============================================================================
; bootloader sample 01 for CODEGATE 2011 
;==============================================================================
; Author    somma (somma@fsksec.co.kr)
;           http://somma.egloos.com
;==============================================================================
; All rights reserved by FSK Security Co.Ltd.
;==============================================================================

ORG 0
BITS 16
CPU 486

jmp 0x07c0:bootsector_entry

;==============================================================================
; data area
;==============================================================================
welcome     db      'welcome to CODEGATE 2011 training course!!',13,10,0
rebootmsg   db      'press any key to reboot system...',13,10,0


;------------------------------------------------------------------------------
; print message to screen
;------------------------------------------------------------------------------
write_msg: 
        lodsb                   ; load byte at ds:si into al
        or  al,al               ; test if character is 0 (end)
        jz  done
        mov ah,0eh              ; put character
        mov bx,0007             ; attribute
        int 0x10                ; call BIOS
        jmp write_msg
    done:
        ret

;------------------------------------------------------------------------------
; clear screen
;------------------------------------------------------------------------------
clear_screen:
        mov ax, 0x0003
        int 0x10
        ret

;------------------------------------------------------------------------------
; wait for key input
;------------------------------------------------------------------------------
getkey:
        mov ah, 0
        int 016h
        ret

;------------------------------------------------------------------------------
; reboot machine
;------------------------------------------------------------------------------
reboot:
    mov     si, rebootmsg
    call    write_msg
    call    getkey
    db      0EAh                 ; machine language to jump to FFFF:0000 (reboot)

    dw 0000h
    dw 0FFFFh
    ; no ret required; we're rebooting! (Hey, I just saved a byte :) 

;==============================================================================
; bootsector_entry
;==============================================================================
bootsector_entry:
	mov		ax, 0x07c0
	mov		ds, ax

    ; setup stack for call instruction
    ;
	cli
	mov		ax, 0x01000
	mov		ss, ax
	mov		sp, 0xffff
	sti

    ; clear screen
    ;
    call    clear_screen
    
    ; write message
    ; 
    mov     si, welcome
    call    write_msg

    ; reboot system
    ;
    call    reboot
    

;#############################
;##  Boot Sector Signature  ##
;#############################

    times   510-($-$$)    db 0	
	dw      0AA55h
