;==============================================================================
; bootkit sample for for CODEGATE 2011 
;
;==============================================================================
; Author    somma (somma@fsksec.co.kr)
;           http://somma.egloos.com
;==============================================================================
; All rights reserved by FSK Security Co.Ltd.
;==============================================================================
BITS	16

; cs = magic_room 
;
jmp bootloader_start

; disk image layout
; 0                    +512                  +512                  +512
; +---------------------+---------------------+---------------------+
; |    bootsector.bin   |   bootloader.bin    |  ntpayload.bin      |
; +---------------------+---------------------+---------------------+
;
;
; memory layout    
;
; 0x07c0:0000                  0xfree_space         +512
; +---------------------+        +---------------------+
; | bootsector.bin      |  ~~~   | bootloader.bin      |
; +---------------------+        +---------------------+
;

;==============================================================================
; data                         
;==============================================================================
    msg_os_boot	    db '[FSK] Welcome to CODEGATE 2011 .............',0xd,0
 
    

;--------------------------------------------------------------------------
; Dump ds:si to screen.
;--------------------------------------------------------------------------
message:
	pusha
	pushf
	
	.printchar:	
		lodsb                   ; load byte at ds:si into al
		or al,al                ; test if character is 0 (end)
		jz .done
		mov ah,0eh              ; put character
		mov bx,0007             ; attribute
		int 0x10                ; call BIOS
		jmp .printchar
	.done:
		popf
		popa
		ret

;--------------------------------------------------------------------------
; clears the screen by switching to mode 3
; ->it also reset the writing cursor position
;--------------------------------------------------------------------------
clear_screen:
	push ax
	mov ax, 0x0003
	int 0x10	
	pop ax
	ret



;--------------------------------------------------------------------------
;
;--------------------------------------------------------------------------
bootloader_start:	
	xor		eax, eax    
	mov     ax, cs
	mov     ds, ax
    mov     es, ax

	; make stack
	; 
    xor     bx, bx
    mov     ss, bx
    mov     [ss:7BFEh], sp
    mov     sp, 7BFEh
    
   	call	clear_screen
    
	mov		si, msg_os_boot
	call	message
	
	mov     ah, 0               ; wait for key...
	int     0x016

	load_os_mbr:
        mov		ax, 0x07c0				;BOOT_SEG
		mov		es, ax
		xor		bx, bx					; dest = 0x7c00:0000	
		mov		ax, 0x0201
		mov		cx, 0001
		mov		dx, 0080h
		int		13h
		jc		load_os_mbr

		jmp		0x07c0:0x0000
        
        hlt            
        ;  hdd  ġ mbr  εǾ  OS   

         